// {̧قDoxygenp̏Ă܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* \li ̧:               eeprom.c
* \li ߲:             IAR EWAAVR 3.10c
* \li xҰ:            avr@atmel.com
*
* \li x޲:         EEPROM/ݔ\͂gpłS޲B
*                         {ATmega48pɏĂ܂B
*
* \li pLq:           AVR103 - EEPROM۸ݸޓʂ̎gp@
*
* \li e:               ႦATmega48ł
*                         EEPROM/ݔ\͎gp@̗
*                         SĂEEPROM۸ݸޓʂ͌Ă܂B
*                         Ⴆ΁A+݁Â݁Â݂
*
*                         $Revision: 1.6 $
*                         $Date: Friday, February 11, 2005 07:16:44 UTC $
****************************************************************************/
#include <ioavr.h>
#include <inavr.h>



/* EEPROMޯĂ͊e޲ňقȂ閼O܂B */
#ifndef EEPE
		#define EEPE  EEWE  //!< EEPROM ۸/݋
		#define EEMPE EEMWE //!< EEPROM Ͻ ۸/݋
#endif



/* 2͕sKɂ޲̲ݸٰ ̧قŒ`Ă܂B */
#define EEPM1 5 //!< EEPROM Programming Mode Bit 1.
#define EEPM0 4 //!< EEPROM Programming Mode Bit 0.



/* ޗeʍ팸̂߂̒`B */
#define EEPROM_IGNORE_SELFPROG //!< SPM֌W׸ނ߰ݸނ폜



/*! \brief  EEPROM޲ēǂݍ
 *
 *  {֐͗^ꂽEEPROMڽ1޲Ăǂ݂܂B
 *
 *  \note  CPUEEPROMǂݍݒ4ۯ ْ~܂B
 *
 *  \param  addr  ǂނ߂EEPROMڽ
 *  \return  EEPROMڽ޲ēǂݍ
 */
char EEPROM_GetChar( unsigned int addr )
{
	do {} while( EECR & (1<<EEPE) ); // O݂̊ҋ@
	EEAR = addr; // EEPROMڽ ڼ޽ݒ
	EECR = (1<<EERE); // EEPROMǂݍݓJn
	return EEDR; // EEPROM̓ǂݍ޲ĂƋɕA
}



/*! \brief  EEPROMւ޲ď
 *
 *  {֐͗^ꂽEEPROMڽ1޲Ă܂B
 *  łIEEPROM۸ݸޓʂIԂ߂ɁA
 *  ޲ĂƐVlԂ̈Ⴂgp܂B
 *
 *  \note  CPUEEPROM۸ݸޒ2ۯ ْ~܂B
 *
 *  \note  {֐߂ƂAVEEPROMlEEPROM۸ݸގԌo߂܂
 *         pł܂B۸ݸނIꂽ𒲂ׂ邽߂ɁA
 *         EECREEPEޯĂ߰ݸނׂłB
 *
 *  \note  EEPROM_GetChar()֐EEPEޯĂIɒׂ܂B
 *
 *  \param  addr  ߂EEPROMڽ
 *  \param  new_value  VEEPROMl
 */
void EEPROM_PutChar( unsigned int addr, char new_value )
{
	char old_value; // EEPROMl
	char diff_mask; // lAƐVlXOR

	unsigned char old_interrupt; // {Jn_̑S荞݋ޯĕۑl
	old_interrupt = __save_interrupt(); // S荞݋ޯĒlۑ
	__disable_interrupt(); // ݑɑ΂񕪒fۏ
	
	do {} while( EECR & (1<<EEPE) ); // Ȍ݂̊ҋ@
	#ifndef EEPROM_IGNORE_SELFPROG
	do {} while( SPMCSR & (1<<SELFPRGEN) ); // SPMߏ̊ҋ@
	#endif
	
	EEAR = addr; // EEPROMڽ ڼ޽ݒ
	EECR = (1<<EERE); // EEPROMǂݍݓJn
	old_value = EEDR; // EEPROMl擾
	diff_mask = old_value ^ new_value; // VԂ̑ޯĒl擾
	
	// Vl1ɕύXޯĂL邩
	if( diff_mask & new_value ) {
		// AޯĂ1ɏׂKv邱ƂmB
		
		// Vl$FFȊO𒲍
		if( new_value != 0xff ) {
			// AޯĂ0۸тׂKv邱ƂmB
			
			EEDR = new_value; // EEPROMް ڼ޽ݒ
			EECR = (1<<EEMPE) | // Ͻ݋ޯĐݒ
			       (0<<EEPM1) | (0<<EEPM0); // +ݓw
			EECR |= (1<<EEPE);  // +ݓJn
		} else {
			// ASޯĂׂł邱ƂmB

			EECR = (1<<EEMPE) | // Ͻ݋ޯĐݒ
			       (1<<EEPM0);  // ̂ݎw
			EECR |= (1<<EEPE);  // ̂݊Jn
		}
	} else {
		// AޯĂ1ɏׂKvȂƂmB
		
		// l1ύXޯĂ邩𒲍
		if( diff_mask ) {
			// AޯĂ0۸тׂKv邱ƂmB
			
			EEDR = new_value;   // EEPROMް ڼ޽ݒ
			EECR = (1<<EEMPE) | // Ͻ݋ޯĐݒ
			       (1<<EEPM1);  // ݓ̂ݎw
			EECR |= (1<<EEPE);  // ݓ̂݊Jn
		}
	}
	
	__restore_interrupt( old_interrupt ); // S荞݋ޯĉ
}



/*! \brief  sJn
 *
 *  main()֐EEPROM_GetChar()EEPROM_PutChar()֐܂B
 *  EEPROMɏl͑SĂEEPROM۸ݸޓʂ
 *  悤ɑI΂Ă܂B
 */
__C_task void main()
{
	char t; // ꎞ޲Ēl
	unsigned int addr = 0x10; // gpEEPROMڽ
	
	// EEPROM_GetChar()֐
	t = EEPROM_GetChar( addr );
	
	// ޲đS̏s
	EEPROM_PutChar( addr, 0xff );

	// ޯĂ0ւ̕ύXs
	EEPROM_PutChar( addr, 0x0f );
	
	// ւޯĕύXs
	EEPROM_PutChar( addr, 0xf0 );
	
	// ύXȂs
	EEPROM_PutChar( addr, 0xf0 );
	
	// l
	EEPROM_PutChar( addr, t );
	
	for(;;); // JԂ
}

// ̧ق̍Ō
